init 1 python:
    import random
    random.seed()
    
    class Type():
        def __init__(self, name, cost, description, outofbattle, inbattle):
            self.name = name
            self.cost = cost
            self.description = description
            self.outofbattle = outofbattle
            self.inbattle = inbattle
        
        def effect(self, user):
            return
        
        def use(self, user, list):
            def real_func():
                value = self.effect(user)
                
                if value is not 0 and (list is not user.spells or not user.gambit or random.random() > 0.33):
                    list.remove(self)
                return value
            
            return real_func
        
        def describe(self):
            x(self.description, interact=False)
            return False
    
    class Potion(Type):
        def __init__(self):
            Type.__init__(self, "Potion", 10, "Funny coloured potion cures light wounds.", True, True)
        
        def effect(self, user):
            user.recover_damage(4)
            x(fill_names("%x recover%s a little bit!",user))
            
            return True
    
    class Redboots(Type):
        def __init__(self):
            Type.__init__(self, "Red boots", 40, "Red boots make you go faster.", True, False)
        
        def effect(self, user):
            user.speed += 2
            x(fill_names("%x can move a whole lot faster now.", user))
            
            return True
    
    class Fullpotion(Type):
        def __init__(self):
            Type.__init__(self, "Strong potion", 30, "Strong potion recovers all health.", True, True)
        
        def effect(self, user):
            user.health = user.maxhealth
            x(fill_names("%x feel%s at perfect health again!", user))
            
            return True
    
    class Orcishtoken(Type):
        def __init__(self):
            Type.__init__(self, "Orcish token", 200, "So valuable to orcs you could probably use it to avoid a fight... but why would you?", True, False)
        
        def effect(self, user):
            x("There's nothing to do with it.")
            return 0
    
    class Grindstone(Type):
        def __init__(self):
            Type.__init__(self, "Grindstone", 70, "Used to sharpen the edge of a blade.", True, False)
        
        def effect(self, user):
            user.baseattack += 1
            x(fill_names("%x use%s the worn down grindstone!", user))
            
            return True
    
    class Wizardfeather(Type):
        def __init__(self):
            Type.__init__(self, "Wizard's feather", 150, "Can be easily transformed into the materials for any spell.", True, True)
            self.cancast = [ ]
        
        def updatelist(self, user):
            self.cancast = user.cancast
        
        def effect(self, user):
            def givespell(spell):
                def func():
                    user.spells.append(spell)
                    return True
                
                return func
            
            item = None
            self.updatelist(user)
            
            while not item:
                ui.layer("overlay")
                ui.window(xfill=False, xpos=1.0, xanchor=1.0, ypos=0.65, yminimum=0, yanchor=1.0, xmargin=20)
                ui.vbox()
                for i in self.cancast:
                    ui.textbutton(i.name, hovered=ui.returns(i.describe), clicked=ui.returns(givespell(i)))
                ui.textbutton("Cancel", clicked=ui.returns(ui.returns(0)))
                ui.close()
                ui.close()
                
                item = ui.interact()()
                if item is 0:
                    return 0
            
            return True
    
    class Wizarddust(Wizardfeather):
        def __init__(self):
            Type.__init__(self, "Wizard's dust", 70, "Can be easily transformed into the materials for weak spells.", True, True)
            self.cancast = [ ]
        
        def updatelist(self, user):
            self.cancast = user.cancast[:-2]
    
    class Leatherpadding(Type):
        def __init__(self):
            Type.__init__(self, "Leather padding", 70, "Can be used to strengthen armour a little.", True, False)
        
        def effect(self, user):
            user.hitchance += 0.1
            x(fill_names("%x strap%s on a thin layer of leather padding...", user))
    
    class Fireball(Type):
        def __init__(self):
            Type.__init__(self, "Fireball", 70, "Tosses a large sphere that explodes into flames, damages all enemies.", False, True)
        
        def effect(self, user):
            for i in currentbattle:
                if not i.friendly:
                    i.take_damage(user, 4, False)
            
            renpy.restart_interaction()
            x(fill_names("%x throw%s a fireball... massive damage!", user))
            
            return True
    
    class Spark(Type):
        def __init__(self):
            Type.__init__(self, "Spark", 10, "Tiny bolt of magic that never misses.", False, True)
        
        def effect(self, user):
            target = select_one(False)
            if not target:
                return 0
            
            target.take_damage(user, 2, False)
            x(fill_names("%x hit%s %y right in the face with a magic bolt!", user, target))
            
            return True
    
    class Lightning(Type):
        def __init__(self):
            Type.__init__(self, "Lightning", 200, "300 megavolts of death from above.", False, True)
        
        def effect(self, user):
            target = select_one(False)
            if not target:
                return 0
            
            target.take_damage(user, 100, False)
            x(fill_names("%x calls down a bolt of divine fury on %y and strikes it dead!", user, target))
            
            return True
    
    class Slow(Type):
        def __init__(self):
            Type.__init__(self, "Slow", 10, "Slows down a single enemy for the rest of the fight.", False, True)
        
        def effect(self, user):
            target = select_one(False)
            if not target:
                return 0
            
            target.tempspeed -= 10
            target.stopped = 1
            target.take_damage(user, 0, False)
            battleorder()
            x(fill_names("%x use%s magic to slow %y right down!", user, target))
            
            return True
    
    class Paralyze(Type):
        def __init__(self):
            Type.__init__(self, "Paralyze", 20, "Targetted damage causes a single enemy to become temporarily unable to move at all.", False, True)
        
        def effect(self, user):
            target = select_one(False)
            if not target:
                return 0
            
            target.stopped = 3
            target.take_damage(user, 0, False)
            x(fill_names("%x strike%s %y so hard, he can't move!", user, target))
            
            return True
    
    class Blizzard(Type):
        def __init__(self):
            Type.__init__(self, "Blizzard", 40, "Brief but massive snowstorm only hits enemies, and hits hard.", False, True)
        
        def effect(self, user):
            for i in currentbattle:
                if not i.friendly:
                    i.take_damage(user, 2, False)
            
            x(fill_names("%x summon%s a short blizzard, damaging all!", user))
            
            return True
    
    class Superheat(Type):
        def __init__(self):
            Type.__init__(self, "Superheat", 30, "Superheated weapon adds extra sting.", False, True)
        
        def effect(self, user):
            target = select_one(False)
            if not target:
                return 0
            
            user.attack(target)
            target.health -= 4
            
            return True
    
    class Blessedstrike(Type):
        def __init__(self):
            Type.__init__(self, "Blessed strike", 30, "Magically charged weapon always hits.", False, True)
        
        def effect(self, user):
            target = select_one(False)
            if not target:
                return 0
            
            user.temphitbonus += 2.0
            user.attack(target)
            target.health -= 1
            user.temphitbonus -= 2.0
            
            return True
    
    class Cure(Type):
        def __init__(self):
            Type.__init__(self, "Cure", 10, "Cures light injuries.", True, True)
        
        def effect(self, user):
            target = select_one(True)
            if not target:
                return 0
            
            target.recover_damage(2)
            x(fill_names("%x magically heal%s %y's wounds a little.", user, target))
            
            return True
    
    class Majorheal(Type):
        def __init__(self):
            Type.__init__(self, "Major heal", 20, "Cures serious injuries.", True, True)
        
        def effect(self, user):
            target = select_one(True)
            if not target:
                return 0
            
            target.recover_damage(5)
            x(fill_names("%x magically cure%s all %y's wounds.", user, target))
            
            return True
    
    class Restore(Type):
        def __init__(self):
            Type.__init__(self, "Restore all", 70, "Restores everyone to perfect health.", True, True)
        
        def effect(self, user):
            for i in party:
                i.recover_damage(100)
            
            x(fill_names("%x restore%s the whole party to full health!", user))
            
            return True
    
    class Haste(Type):
        def __init__(self):
            Type.__init__(self, "Haste", 10, "Magically increases the speed of a single person.", False, True)
        
        def effect(self, user):
            target = select_one(True)
            if not target:
                return 0
            
            target.tempspeed += 10
            target.recover_damage(0)
            
            battleorder()
            
            x(fill_names("%x magically boost%s %y's speed!", user, target))
            
            return True
    
    class Timestop(Type):
        def __init__(self):
            Type.__init__(self, "Time stop", 70, "Briefly freezes all enemies in time.", False, True)
        
        def effect(self, user):
            for i in currentbattle:
                if not i.friendly:
                    i.stopped = 3
                    i.take_damage(user, 0, False)
            
            x(fill_names("%x freeze%s time!", user))
            
            return True
    
    class Protect(Type):
        def __init__(self):
            Type.__init__(self, "Protect", 10, "Adds a thin layer of magic to someone's armour.", False, True)
        
        def effect(self, user):
            target = select_one(True)
            if not target:
                return 0
            
            target.temphitchance += 0.1
            target.recover_damage(0)
            x(fill_names("%x gives%s %y a thin layer of protective aura!", user, target))
            
            return True
    
    class Shield(Type):
        def __init__(self):
            Type.__init__(self, "Shield", 50, "Solid bubble of magic helps shield the whole party.", False, True)
        
        def effect(self, user):
            for i in party:
                i.temphitchance += 0.15
                i.recover_damage(0)
            
            x(fill_names("%x erect%s a magical shield around the whole party!", user))
            
            return True
    
    class Strengthen(Type):
        def __init__(self):
            Type.__init__(self, "Strengthen", 150, "Permanently boost the damage of someone's weapon.", True, True)
        
        def effect(self, user):
            target = select_one(True)
            if not target:
                return 0
            
            target.baseattack += 3
            target.recover_damage(0)
            x(fill_names("%x give%s a permanent damage increase to %y's weapon.", user, target))
            
            return True
